Index: /branches/Scheduling/HeuristicLab.Encodings.ScheduleEncoding/3.3/PermutationWithRepetition/Crossovers/PWRCrossover.cs
===================================================================
--- /branches/Scheduling/HeuristicLab.Encodings.ScheduleEncoding/3.3/PermutationWithRepetition/Crossovers/PWRCrossover.cs	(revision 6406)
+++ /branches/Scheduling/HeuristicLab.Encodings.ScheduleEncoding/3.3/PermutationWithRepetition/Crossovers/PWRCrossover.cs	(revision 6406)
@@ -0,0 +1,51 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Encodings.ScheduleEncoding.PermutationWithRepetition {
+  [Item("PWRCrossover", "An operator which crosses two JSM representations.")]
+  [StorableClass]
+  public abstract class PWRCrossover : ScheduleCrossover<PWREncoding>, IPWROperator {
+
+    [StorableConstructor]
+    protected PWRCrossover(bool deserializing) : base(deserializing) { }
+    protected PWRCrossover(PWRCrossover original, Cloner cloner) : base(original, cloner) { }
+    public PWRCrossover()
+      : base() {
+      ParentsParameter.ActualName = "PermutationWithRepetition";
+      ChildParameter.ActualName = "PermutationWithRepetition";
+    }
+
+    public abstract PWREncoding Cross(IRandom random, PWREncoding parent1, PWREncoding parent2);
+
+    public override IOperation Apply() {
+      ItemArray<PWREncoding> parents = ParentsParameter.ActualValue;
+
+      ChildParameter.ActualValue =
+        Cross(RandomParameter.ActualValue, parents[0] as PWREncoding, parents[1] as PWREncoding);
+
+      return base.Apply();
+    }
+  }
+}
Index: /branches/Scheduling/HeuristicLab.Encodings.ScheduleEncoding/3.3/PermutationWithRepetition/Crossovers/PWRGOXCrossover.cs
===================================================================
--- /branches/Scheduling/HeuristicLab.Encodings.ScheduleEncoding/3.3/PermutationWithRepetition/Crossovers/PWRGOXCrossover.cs	(revision 6406)
+++ /branches/Scheduling/HeuristicLab.Encodings.ScheduleEncoding/3.3/PermutationWithRepetition/Crossovers/PWRGOXCrossover.cs	(revision 6406)
@@ -0,0 +1,96 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Collections.Generic;
+using System.Linq;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Encodings.IntegerVectorEncoding;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Encodings.ScheduleEncoding.PermutationWithRepetition {
+  [Item("PWRGeneralizationOrderCrossover", "Represents a crossover operation swapping sequences of the parents to generate offspring.")]
+  [StorableClass]
+  public class PWRGOXCrossover : PWRCrossover {
+    [StorableConstructor]
+    protected PWRGOXCrossover(bool deserializing) : base(deserializing) { }
+    protected PWRGOXCrossover(PWRGOXCrossover original, Cloner cloner)
+      : base(original, cloner) {
+    }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new PWRGOXCrossover(this, cloner);
+    }
+    public PWRGOXCrossover() : base() { }
+
+    private static int[] GetLookUpForIndividual(List<int> p) {
+      int[] result = new int[p.Count];
+      Dictionary<int, int> lookUpTable = new Dictionary<int, int>();
+
+      for (int i = 0; i < p.Count; i++) {
+        if (!lookUpTable.ContainsKey(p[i]))
+          lookUpTable.Add(p[i], 0);
+        result[i] = lookUpTable[p[i]];
+        lookUpTable[p[i]]++;
+      }
+
+      return result;
+    }
+    public static PWREncoding Apply(IRandom random, PWREncoding parent1, PWREncoding parent2) {
+      PWREncoding result = new PWREncoding();
+
+      List<int> p1 = ((IntegerVector)(parent1.PermutationWithRepetition.Clone())).ToList<int>();
+      List<int> p2 = ((IntegerVector)(parent2.PermutationWithRepetition.Clone())).ToList<int>();
+      List<int> child = new List<int>();
+
+      int[] lookUpArrayP1 = GetLookUpForIndividual(p1);
+      int[] lookUpArrayP2 = GetLookUpForIndividual(p2);
+
+      int xStringLength = p1.Count / 2;
+      int xStringPosition = random.Next(p1.Count / 2);
+
+      //insert elements from parent1 that dont conflict with the "selected" elements form parent2
+      for (int i = 0; i < p1.Count; i++) {
+        bool isSelected = false;
+        for (int j = xStringPosition; j < xStringPosition + xStringLength; j++) {
+          if (p1[i] == p2[j] && lookUpArrayP1[i] == lookUpArrayP2[j])
+            isSelected = true;
+        }
+        if (!isSelected)
+          child.Add(p1[i]);
+      }
+
+      for (int i = xStringPosition; i < xStringPosition + xStringLength; i++) {
+        child.Insert(i, p2[i]);
+      }
+
+      result.PermutationWithRepetition = new IntegerVector(child.ToArray());
+      return result;
+    }
+
+    public override PWREncoding Cross(IRandom random, PWREncoding parent1, PWREncoding parent2) {
+      return Apply(random, parent1, parent2);
+    }
+
+
+
+
+  }
+}
Index: /branches/Scheduling/HeuristicLab.Encodings.ScheduleEncoding/3.3/PermutationWithRepetition/Crossovers/PWRPPXCrossover.cs
===================================================================
--- /branches/Scheduling/HeuristicLab.Encodings.ScheduleEncoding/3.3/PermutationWithRepetition/Crossovers/PWRPPXCrossover.cs	(revision 6406)
+++ /branches/Scheduling/HeuristicLab.Encodings.ScheduleEncoding/3.3/PermutationWithRepetition/Crossovers/PWRPPXCrossover.cs	(revision 6406)
@@ -0,0 +1,77 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Collections.Generic;
+using System.Linq;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Encodings.IntegerVectorEncoding;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Encodings.ScheduleEncoding.PermutationWithRepetition {
+  [Item("PWROrderCrossover", "Represents a crossover operation swapping sequences of the parents to generate offspring.")]
+  [StorableClass]
+  public class PWRPPXCrossover : PWRCrossover {
+    [StorableConstructor]
+    protected PWRPPXCrossover(bool deserializing) : base(deserializing) { }
+    protected PWRPPXCrossover(PWRPPXCrossover original, Cloner cloner)
+      : base(original, cloner) {
+    }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new PWRPPXCrossover(this, cloner);
+    }
+    public PWRPPXCrossover() : base() { }
+
+    public static PWREncoding Apply(IRandom random, PWREncoding parent1, PWREncoding parent2) {
+      PWREncoding result = new PWREncoding();
+      List<int> p1 = ((IntegerVector)(parent1.PermutationWithRepetition.Clone())).ToList<int>();
+      List<int> p2 = ((IntegerVector)(parent2.PermutationWithRepetition.Clone())).ToList<int>();
+      List<int> child = new List<int>();
+
+      bool[] lookUpTable = new bool[parent1.PermutationWithRepetition.Length];
+      for (int i = 0; i < lookUpTable.Length; i++) {
+        lookUpTable[i] = random.Next(2) == 1;
+      }
+
+      foreach (bool b in lookUpTable) {
+        if (b) {
+          child.Add(p1[0]);
+          p2.Remove(p1[0]);
+          p1.RemoveAt(0);
+        } else {
+          child.Add(p2[0]);
+          p1.Remove(p2[0]);
+          p2.RemoveAt(0);
+        }
+      }
+
+      result.PermutationWithRepetition = new IntegerVector(child.ToArray());
+
+      return result;
+    }
+
+    public override PWREncoding Cross(IRandom random, PWREncoding parent1, PWREncoding parent2) {
+      return Apply(random, parent1, parent2);
+    }
+
+
+  }
+}
Index: /branches/Scheduling/HeuristicLab.Encodings.ScheduleEncoding/3.3/PermutationWithRepetition/Manipulators/PWRManipulator.cs
===================================================================
--- /branches/Scheduling/HeuristicLab.Encodings.ScheduleEncoding/3.3/PermutationWithRepetition/Manipulators/PWRManipulator.cs	(revision 6406)
+++ /branches/Scheduling/HeuristicLab.Encodings.ScheduleEncoding/3.3/PermutationWithRepetition/Manipulators/PWRManipulator.cs	(revision 6406)
@@ -0,0 +1,48 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Encodings.ScheduleEncoding.PermutationWithRepetition {
+  [Item("PWRManipulator", "An operator which manipulates a PWR representation.")]
+  [StorableClass]
+  public abstract class PWRManipulator : ScheduleManipulator<PWREncoding>, IPWROperator {
+    [StorableConstructor]
+    protected PWRManipulator(bool deserializing) : base(deserializing) { }
+    protected PWRManipulator(PWRManipulator original, Cloner cloner) : base(original, cloner) { }
+    public PWRManipulator()
+      : base() {
+      ScheduleEncodingParameter.ActualName = "PermutationWithRepetition";
+    }
+
+    protected abstract void Manipulate(IRandom random, PWREncoding individual);
+
+
+    public override IOperation Apply() {
+      PWREncoding solution = ScheduleEncodingParameter.ActualValue;
+      Manipulate(RandomParameter.ActualValue, solution);
+      return base.Apply();
+    }
+
+  }
+}
Index: /branches/Scheduling/HeuristicLab.Encodings.ScheduleEncoding/3.3/PermutationWithRepetition/Manipulators/PWRUniformOnePositionManipulator.cs
===================================================================
--- /branches/Scheduling/HeuristicLab.Encodings.ScheduleEncoding/3.3/PermutationWithRepetition/Manipulators/PWRUniformOnePositionManipulator.cs	(revision 6406)
+++ /branches/Scheduling/HeuristicLab.Encodings.ScheduleEncoding/3.3/PermutationWithRepetition/Manipulators/PWRUniformOnePositionManipulator.cs	(revision 6406)
@@ -0,0 +1,64 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Collections.Generic;
+using System.Linq;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Encodings.IntegerVectorEncoding;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Encodings.ScheduleEncoding.PermutationWithRepetition {
+
+  [Item("PWRUniformOnePositionManipulator", "Represents a manipulation operation inserting parts of the individual at another position.")]
+  [StorableClass]
+  public class PWRUniformOnePositionManipulator : PWRManipulator {
+    [StorableConstructor]
+    protected PWRUniformOnePositionManipulator(bool deserializing) : base(deserializing) { }
+    protected PWRUniformOnePositionManipulator(PWRUniformOnePositionManipulator original, Cloner cloner)
+      : base(original, cloner) {
+    }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new PWRUniformOnePositionManipulator(this, cloner);
+    }
+    public PWRUniformOnePositionManipulator() : base() { }
+
+    public static void Apply(IRandom random, PWREncoding individual) {
+      int cutIndex = random.Next(individual.PermutationWithRepetition.Length);
+      int insertIndex = random.Next(individual.PermutationWithRepetition.Length);
+      List<int> perm = ((IntegerVector)(individual.PermutationWithRepetition.Clone())).ToList<int>();
+      int aux = perm[cutIndex];
+      if (cutIndex > insertIndex) {
+        perm.RemoveAt(cutIndex);
+        perm.Insert(insertIndex, aux);
+      } else {
+        perm.Insert(insertIndex, aux);
+        perm.RemoveAt(cutIndex);
+      }
+      individual.PermutationWithRepetition = new IntegerVector(perm.ToArray());
+    }
+
+    protected override void Manipulate(IRandom random, PWREncoding individual) {
+      Apply(random, individual);
+    }
+
+  }
+}
Index: /branches/Scheduling/HeuristicLab.Encodings.ScheduleEncoding/3.3/PermutationWithRepetition/PWREncoding.cs
===================================================================
--- /branches/Scheduling/HeuristicLab.Encodings.ScheduleEncoding/3.3/PermutationWithRepetition/PWREncoding.cs	(revision 6406)
+++ /branches/Scheduling/HeuristicLab.Encodings.ScheduleEncoding/3.3/PermutationWithRepetition/PWREncoding.cs	(revision 6406)
@@ -0,0 +1,96 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Text;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Encodings.IntegerVectorEncoding;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Encodings.ScheduleEncoding.PermutationWithRepetition {
+  [Item("PermutationWithRepetitionEncoding", "Represents a encoding for a standard JobShop Scheduling Problem.")]
+  [StorableClass]
+  public class PWREncoding : Item, IScheduleEncoding {
+    [Storable]
+    public IntegerVector PermutationWithRepetition { get; set; }
+
+
+    [StorableConstructor]
+    protected PWREncoding(bool deserializing) : base(deserializing) { }
+    protected PWREncoding(PWREncoding original, Cloner cloner)
+      : base(original, cloner) {
+      this.PermutationWithRepetition = cloner.Clone(original.PermutationWithRepetition);
+    }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new PWREncoding(this, cloner);
+    }
+    public PWREncoding()
+      : base() {
+      PermutationWithRepetition = new IntegerVector();
+    }
+
+    public PWREncoding(int problemDimension, IRandom random)
+      : base() {
+      PermutationWithRepetition = new IntegerVector(problemDimension * problemDimension);
+      int[] lookUpTable = new int[problemDimension];
+
+      for (int i = 0; i < PermutationWithRepetition.Length; i++) {
+        int newValue = random.Next(problemDimension);
+        while (lookUpTable[newValue] >= problemDimension)
+          newValue = random.Next(problemDimension);
+
+        PermutationWithRepetition[i] = newValue;
+
+        lookUpTable[newValue]++;
+      }
+    }
+
+    public override string ToString() {
+      StringBuilder sb = new StringBuilder();
+      sb.Append("[ ");
+      foreach (int i in PermutationWithRepetition) {
+        sb.Append(i + " ");
+      }
+      sb.Append("]");
+
+      return sb.ToString();
+    }
+
+    public override bool Equals(object obj) {
+      if (obj.GetType() == typeof(PWREncoding))
+        return AreEqual(this, obj as PWREncoding);
+      else
+        return base.Equals(obj);
+    }
+
+    private bool AreEqual(PWREncoding pWREncoding1, PWREncoding pWREncoding2) {
+      if (pWREncoding1.PermutationWithRepetition.Length != pWREncoding2.PermutationWithRepetition.Length)
+        return false;
+      for (int i = 0; i < pWREncoding1.PermutationWithRepetition.Length; i++) {
+        if (pWREncoding1.PermutationWithRepetition[i] != pWREncoding2.PermutationWithRepetition[i])
+          return false;
+      }
+      return true;
+    }
+
+
+  }
+}
Index: /branches/Scheduling/HeuristicLab.Encodings.ScheduleEncoding/3.3/PermutationWithRepetition/PWRRandomCreator.cs
===================================================================
--- /branches/Scheduling/HeuristicLab.Encodings.ScheduleEncoding/3.3/PermutationWithRepetition/PWRRandomCreator.cs	(revision 6406)
+++ /branches/Scheduling/HeuristicLab.Encodings.ScheduleEncoding/3.3/PermutationWithRepetition/PWRRandomCreator.cs	(revision 6406)
@@ -0,0 +1,71 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Optimization;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Encodings.ScheduleEncoding.PermutationWithRepetition {
+  [Item("PermutationWithRepetitionRandomCreator", "Creates PWR-individuals at random.")]
+  [StorableClass]
+  public class PWRRandomCreator : ScheduleCreator<PWREncoding>, IStochasticOperator {
+    public IRandom Random {
+      get { return RandomParameter.ActualValue; }
+    }
+
+    public ILookupParameter<IRandom> RandomParameter {
+      get { return (LookupParameter<IRandom>)Parameters["Random"]; }
+    }
+    public IValueLookupParameter<IntValue> JobsParameter {
+      get { return (IValueLookupParameter<IntValue>)Parameters["Jobs"]; }
+    }
+    public IValueLookupParameter<IntValue> ResourcesParameter {
+      get { return (IValueLookupParameter<IntValue>)Parameters["Resources"]; }
+    }
+
+    [StorableConstructor]
+    protected PWRRandomCreator(bool deserializing) : base(deserializing) { }
+    protected PWRRandomCreator(PWRRandomCreator original, Cloner cloner)
+      : base(original, cloner) {
+    }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new PWRRandomCreator(this, cloner);
+    }
+
+    public PWRRandomCreator()
+      : base() {
+      Parameters.Add(new LookupParameter<IRandom>("Random", "The pseudo random number generator."));
+      Parameters.Add(new ValueLookupParameter<IntValue>("Jobs", "The number of jobs handled in this problem instance."));
+      Parameters.Add(new ValueLookupParameter<IntValue>("Resources", "The number of resources used in this problem instance."));
+
+      ScheduleEncodingParameter.ActualName = "PermutationWithRepetition";
+    }
+
+
+    protected override PWREncoding CreateSolution() {
+      PWREncoding result = new PWREncoding(JobsParameter.ActualValue.Value, Random);
+      return result;
+    }
+  }
+}
Index: /branches/Scheduling/HeuristicLab.Encodings.ScheduleEncoding/3.3/Plugin.cs
===================================================================
--- /branches/Scheduling/HeuristicLab.Encodings.ScheduleEncoding/3.3/Plugin.cs	(revision 6406)
+++ /branches/Scheduling/HeuristicLab.Encodings.ScheduleEncoding/3.3/Plugin.cs	(revision 6406)
@@ -0,0 +1,29 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.PluginInfrastructure;
+
+namespace HeuristicLab.Encodings.ScheduleEncoding {
+  [Plugin("HeuristicLab.Encodings.ScheduleEncoding", "3.3.3.0")]
+  [PluginFile("HeuristicLab.Encodings.ScheduleEncoding-3.3.dll", PluginFileType.Assembly)]
+  public class HeuristicLabEncodingsScheduleEncodingPlugin : PluginBase {
+  }
+}
Index: /branches/Scheduling/HeuristicLab.Encodings.ScheduleEncoding/3.3/Plugin.cs.frame
===================================================================
--- /branches/Scheduling/HeuristicLab.Encodings.ScheduleEncoding/3.3/Plugin.cs.frame	(revision 6406)
+++ /branches/Scheduling/HeuristicLab.Encodings.ScheduleEncoding/3.3/Plugin.cs.frame	(revision 6406)
@@ -0,0 +1,29 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.PluginInfrastructure;
+
+namespace HeuristicLab.Encodings.ScheduleEncoding {
+  [Plugin("HeuristicLab.Encodings.ScheduleEncoding", "3.3.3.$WCREV$")]
+  [PluginFile("HeuristicLab.Encodings.ScheduleEncoding-3.3.dll", PluginFileType.Assembly)]
+  public class HeuristicLabEncodingsScheduleEncodingPlugin : PluginBase {
+  }
+}
Index: /branches/Scheduling/HeuristicLab.Encodings.ScheduleEncoding/3.3/PriorityRulesVector/Crossovers/PRVCrossover.cs
===================================================================
--- /branches/Scheduling/HeuristicLab.Encodings.ScheduleEncoding/3.3/PriorityRulesVector/Crossovers/PRVCrossover.cs	(revision 6406)
+++ /branches/Scheduling/HeuristicLab.Encodings.ScheduleEncoding/3.3/PriorityRulesVector/Crossovers/PRVCrossover.cs	(revision 6406)
@@ -0,0 +1,49 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Encodings.ScheduleEncoding.PriorityRulesVector {
+  [Item("PRVCrossover", "An operator which crosses two PRV representations.")]
+  [StorableClass]
+  public abstract class PRVCrossover : ScheduleCrossover<PRVEncoding>, IPRVOperator {
+    [StorableConstructor]
+    protected PRVCrossover(bool deserializing) : base(deserializing) { }
+    protected PRVCrossover(PRVCrossover original, Cloner cloner) : base(original, cloner) { }
+    public PRVCrossover()
+      : base() {
+      ParentsParameter.ActualName = "PriorityRulesVector";
+      ChildParameter.ActualName = "PriorityRulesVector";
+    }
+
+
+    public abstract PRVEncoding Cross(IRandom random, PRVEncoding parent1, PRVEncoding parent2);
+
+    public override IOperation Apply() {
+      ItemArray<PRVEncoding> parents = ParentsParameter.ActualValue;
+      ChildParameter.ActualValue =
+        Cross(RandomParameter.ActualValue, parents[0] as PRVEncoding, parents[1] as PRVEncoding);
+      return base.Apply();
+    }
+  }
+}
Index: /branches/Scheduling/HeuristicLab.Encodings.ScheduleEncoding/3.3/PriorityRulesVector/Crossovers/PRVDiscreteCrossover.cs
===================================================================
--- /branches/Scheduling/HeuristicLab.Encodings.ScheduleEncoding/3.3/PriorityRulesVector/Crossovers/PRVDiscreteCrossover.cs	(revision 6406)
+++ /branches/Scheduling/HeuristicLab.Encodings.ScheduleEncoding/3.3/PriorityRulesVector/Crossovers/PRVDiscreteCrossover.cs	(revision 6406)
@@ -0,0 +1,49 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Encodings.IntegerVectorEncoding;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Encodings.ScheduleEncoding.PriorityRulesVector {
+  [Item("PRVDiscreteCrossover", "Represents a crossover operation swapping sequences of the parents to generate offspring.")]
+  [StorableClass]
+  public class PRVDiscreteCrossover : PRVCrossover {
+    [StorableConstructor]
+    protected PRVDiscreteCrossover(bool deserializing) : base(deserializing) { }
+    protected PRVDiscreteCrossover(PRVDiscreteCrossover original, Cloner cloner)
+      : base(original, cloner) {
+    }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new PRVDiscreteCrossover(this, cloner);
+    }
+    public PRVDiscreteCrossover() : base() { }
+
+
+    public static PRVEncoding Apply(IRandom random, PRVEncoding parent1, PRVEncoding parent2) {
+      return new PRVEncoding(DiscreteCrossover.Apply(random, parent1.PriorityRulesVector, parent2.PriorityRulesVector), parent1.NrOfRules);
+    }
+    public override PRVEncoding Cross(IRandom random, PRVEncoding parent1, PRVEncoding parent2) {
+      return Cross(random, parent1, parent2);
+    }
+  }
+}
